﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Docking;

namespace DockingMissingPanes
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnFluentButtonClicked(object sender, RoutedEventArgs e)
        {
            Application.Current.Resources.MergedDictionaries.Clear();
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Fluent;component/Themes/System.Windows.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Fluent;component/Themes/Telerik.Windows.Controls.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Fluent;component/Themes/Telerik.Windows.Controls.Docking.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Fluent;component/Themes/Telerik.Windows.Controls.Navigation.xaml", UriKind.RelativeOrAbsolute)
            });
        }

        private void OnOfficeBlackButtonClicked(object sender, RoutedEventArgs e)
        {
            Application.Current.Resources.MergedDictionaries.Clear();
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Office_Black;component/Themes/System.Windows.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Office_Black;component/Themes/Telerik.Windows.Controls.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Office_Black;component/Themes/Telerik.Windows.Controls.Docking.xaml", UriKind.RelativeOrAbsolute)
            });
            Application.Current.Resources.MergedDictionaries.Add(new ResourceDictionary()
            {
                Source = new Uri("/Telerik.Windows.Themes.Office_Black;component/Themes/Telerik.Windows.Controls.Navigation.xaml", UriKind.RelativeOrAbsolute)
            });
        }
    }

    public class MyDockingPanesFactory : DockingPanesFactory
    {
        protected override void AddPane(Telerik.Windows.Controls.RadDocking radDocking, Telerik.Windows.Controls.RadPane pane)
        {
            var tag = pane.Tag.ToString();
            var paneGroup = radDocking.SplitItems.ToList().FirstOrDefault(i => i.Control.Name.Contains(tag)) as RadPaneGroup;

            if (paneGroup != null)
            {
                paneGroup.Items.Add(pane);
            }
            else
            {
                base.AddPane(radDocking, pane);
            }
        }

        protected override void RemovePane(RadPane pane)
        {
            base.RemovePane(pane);
        }
    }

    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<RadPane> panes;

        public ViewModel()
        {
            this.Panes = new ObservableCollection<RadPane>()
            {
                new RadPane() { Header = "Bottom Pane 1", Tag = "Bottom" },
                new RadPane() { Header = "Bottom Pane 2", Tag = "Bottom" },
                new RadPane() { Header = "Left Pane", Tag = "Left" },
                new RadDocumentPane() { Header = "DocumentHost Pane 1", Tag = "DocumentHost" },
                new RadDocumentPane() { Header = "DocumentHost Pane 2", Tag = "DocumentHost" },
                new RadDocumentPane() { Header = "DocumentHost Pane 3", Tag = "DocumentHost" },
                new RadDocumentPane() { Header = "DocumentHost Pane 4", Tag = "DocumentHost" },
                new RadDocumentPane() { Header = "DocumentHost Pane 5", Tag = "DocumentHost" }
            };
        }

        /// <summary>
        /// Gets or sets Panes and notifies for changes
        /// </summary>
        public ObservableCollection<RadPane> Panes
        {
            get
            {
                return this.panes;
            }

            set
            {
                if (this.panes != value)
                {
                    this.panes = value;
                    this.OnPropertyChanged(() => this.Panes);
                }
            }
        }
    }
}
